## srt 1.4.1

=== CMakeLists.txt ===
#
# SRT - Secure, Reliable, Transport
# Copyright (c) 2018 Haivision Systems Inc.
#
# This Source Code Form is subject to the terms of the Mozilla Public
# License, v. 2.0. If a copy of the MPL was not distributed with this
# file, You can obtain one at http://mozilla.org/MPL/2.0/.
#

cmake_minimum_required (VERSION 2.8.12 FATAL_ERROR)
# XXX This can be potentially done in future, but there still exist
# some dependent project using cmake 2.8 - this can't be done this way.
#cmake_minimum_required (VERSION 3.0.2 FATAL_ERROR)
#project(SRT VERSION "1.4.1")
project(SRT C CXX)

set (CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/scripts")
include(haiUtil)
include(FindPkgConfig)
# XXX See 'if (MINGW)' condition below, may need fixing.
include(FindThreads)
include(CheckFunctionExists)

# Platform shortcuts
string(TOLOWER ${CMAKE_SYSTEM_NAME} SYSNAME_LC)
set_if(DARWIN      ${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
set_if(LINUX       ${CMAKE_SYSTEM_NAME} MATCHES "Linux")
set_if(BSD         ${SYSNAME_LC} MATCHES "bsd$")
set_if(MICROSOFT   WIN32 AND (NOT MINGW AND NOT CYGWIN))
set_if(GNU         ${CMAKE_SYSTEM_NAME} MATCHES "GNU")
set_if(SYMLINKABLE LINUX OR DARWIN OR BSD OR CYGWIN OR GNU)

# Not sure what to do in case of compiling by MSVC.
# This will make installdir in C:\Program Files\SRT then
# inside "bin" and "lib64" directories. At least this maintains
# the current status. Shall this be not desired, override values
# of CMAKE_INSTALL_BINDIR, CMAKE_INSTALL_LIBDIR and CMAKE_INSTALL_INCLUDEDIR.
if (NOT DEFINED CMAKE_INSTALL_LIBDIR)
	include(GNUInstallDirs)
endif()

set (SRT_VERSION 1.4.1)
set_version_variables(SRT_VERSION ${SRT_VERSION})

# The CMAKE_BUILD_TYPE seems not to be always set, weird.
if (NOT DEFINED ENABLE_DEBUG)

	if (CMAKE_BUILD_TYPE STREQUAL "Debug")
		set (ENABLE_DEBUG ON)
	else()
		set (ENABLE_DEBUG OFF)
	endif()
endif()

# Set CMAKE_BUILD_TYPE properly, now that you know
# that ENABLE_DEBUG is set as it should.

if (ENABLE_DEBUG EQUAL 2)
	set (CMAKE_BUILD_TYPE "RelWithDebInfo")
elseif (ENABLE_DEBUG) # 1, ON, YES, TRUE, Y, or any other non-zero number
	set (CMAKE_BUILD_TYPE "Debug")
else()
	set (CMAKE_BUILD_TYPE "Release")
endif()

message(STATUS "BUILD TYPE: ${CMAKE_BUILD_TYPE}")

getVarsWith(ENFORCE_ enforcers)
foreach(ef ${enforcers})
	set (val ${${ef}})
	if (NOT val STREQUAL "")
		set(val =${val})
	endif()
	string(LENGTH ENFORCE_ pflen)
	string(LENGTH ${ef} eflen)
	math(EXPR alen ${eflen}-${pflen})
	string(SUBSTRING ${ef} ${pflen} ${alen} ef)
	message(STATUS "FORCED PP VARIABLE: ${ef}${val}")
	add_definitions(-D${ef}${val})
endforeach()

# option defaults
# XXX CHANGE: Logging is enabled now by default,
# use ENABLE_LOGGING=NO in cmake or
# --disable-logging in configure.
set(ENABLE_HEAVY_LOGGING_DEFAULT OFF)

# Always turn logging on if the build type is debug
if (ENABLE_DEBUG)
	set(ENABLE_HEAVY_LOGGING_DEFAULT ON)
endif()


# options
option(CYGWIN_USE_POSIX "Should the POSIX API be used for cygwin. Ignored if the system isn't cygwin." OFF)
option(ENABLE_CXX11 "Should the c++11 parts (srt-live-transmit) be enabled" ON)
option(ENABLE_APPS "Should the Support Applications be Built?" ON)
option(ENABLE_PROFILE "Should instrument the code for profiling. Ignored for non-GNU compiler." $ENV{HAI_BUILD_PROFILE})
option(ENABLE_LOGGING "Should logging be enabled" ON)
option(ENABLE_HEAVY_LOGGING "Should heavy debug logging be enabled" ${ENABLE_HEAVY_LOGGING_DEFAULT})
option(ENABLE_HAICRYPT_LOGGING "Should logging in haicrypt be enabled" 0)
option(ENABLE_SHARED "Should libsrt be built as a shared library" ON)
option(ENABLE_STATIC "Should libsrt be built as a static library" ON)
option(ENABLE_RELATIVE_LIBPATH "Should application contain relative library paths, like ../lib" OFF)
option(ENABLE_SUFLIP "Should suflip tool be built" OFF)
option(ENABLE_GETNAMEINFO "In-logs sockaddr-to-string should do rev-dns" OFF)
option(ENABLE_UNITTESTS "Enable unit tests" OFF)
option(ENABLE_ENCRYPTION "Enable encryption in SRT" ON)
option(ENABLE_CXX_DEPS "Extra library dependencies in srt.pc for the CXX libraries useful with C language" ON)
option(USE_STATIC_LIBSTDCXX "Should use static rather than shared libstdc++" OFF)
option(ENABLE_INET_PTON "Set to OFF to prevent usage of inet_pton when building against modern SDKs while still requiring compatibility with older Windows versions, such as Windows XP, Windows Server 2003 etc." ON)
option(ENABLE_CODE_COVERAGE "Enable code coverage reporting" OFF)
option(ENABLE_MONOTONIC_CLOCK "Enforced clock_gettime with monotonic clock on GC CV /temporary fix for #729/" OFF)
option(USE_OPENSSL_PC "Use pkg-config to find OpenSSL libraries" ON)
option(USE_BUSY_WAITING "Enable more accurate sending times at a cost of potentially higher CPU load" OFF)
option(USE_GNUSTL "Get c++ library/headers from the gnustl.pc" OFF)

set(TARGET_srt "srt" CACHE STRING "The name for the SRT library")

if (NOT ENABLE_LOGGING)
	set (ENABLE_HEAVY_LOGGING OFF)
	message(STATUS "LOGGING: DISABLED")
else()
	if (ENABLE_HEAVY_LOGGING)
		message(STATUS "LOGGING: HEAVY")
	else()
		message(STATUS "LOGGING: ENABLED")
	endif()
endif()

if (USE_BUSY_WAITING)
	message(STATUS "USE_BUSY_WAITING: ON")
	list(APPEND SRT_EXTRA_CFLAGS "-DUSE_BUSY_WAITING=1")
else()
	message(STATUS "USE_BUSY_WAITING: OFF (default)")
endif()

if ( CYGWIN AND NOT CYGWIN_USE_POSIX )
	set(WIN32 1)
	set(CMAKE_LEGACY_CYGWIN_WIN32 1)
	add_definitions(-DWIN32=1 -DCYGWIN=1)
	message(STATUS "HAVE CYGWIN. Setting backward compat CMAKE_LEGACY_CYGWIN_WIN32 and -DWIN32")
endif()

if (NOT USE_ENCLIB)
	if (USE_GNUTLS)
		message("NOTE: USE_GNUTLS is deprecated. Use -DUSE_ENCLIB=gnutls instead.")
		set (USE_ENCLIB gnutls)
	else()
		set (USE_ENCLIB openssl)
	endif()

endif()

set(USE_ENCLIB "${USE_ENCLIB}" CACHE STRING "The crypto library that SRT uses")
set_property(CACHE USE_ENCLIB PROPERTY STRINGS "openssl" "gnutls" "mbedtls")

# Make sure DLLs and executabes go to the same path regardles of subdirectory
set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR})
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR})
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR})

# Handle WITH_COMPILER_PREFIX and WITH_COMPILER_TYPE options
if (DEFINED WITH_COMPILER_PREFIX)
	message(STATUS "Handling compiler with WITH_COMPILER_PREFIX=${WITH_COMPILER_PREFIX}")
	# Check also type. Default is gcc.
	if (NOT DEFINED WITH_COMPILER_TYPE)
		set (WITH_COMPILER_TYPE gcc)
	endif()

	if (${WITH_COMPILER_TYPE} STREQUAL gcc)
		set (CMAKE_C_COMPILER ${WITH_COMPILER_PREFIX}gcc)
		set (CMAKE_CXX_COMPILER ${WITH_COMPILER_PREFIX}g++)
	elseif (${WITH_COMPILER_TYPE} STREQUAL cc)
		set (CMAKE_C_COMPILER ${WITH_COMPILER_PREFIX}cc)
		set (CMAKE_CXX_COMPILER ${WITH_COMPILER_PREFIX}c++)
	else()
		# Use blindly <command> for C compiler and <command>++ for C++.
		# At least this matches clang.
		set (CMAKE_C_COMPILER ${WITH_COMPILER_PREFIX}${WITH_COMPILER_TYPE})
		set (CMAKE_CXX_COMPILER ${WITH_COMPILER_PREFIX}${WITH_COMPILER_TYPE}++)
	endif()

	message(STATUS "Compiler type: ${WITH_COMPILER_TYPE}. C: ${CMAKE_C_COMPILER}; C++: ${CMAKE_CXX_COMPILER}")
else()
	message(STATUS "No WITH_COMPILER_PREFIX - using C++ compiler ${CMAKE_CXX_COMPILER}")
endif()


if (DEFINED WITH_SRT_TARGET)
	set (TARGET_haisrt ${WITH_SRT_TARGET})
endif()

# When you use crosscompiling, you have to take care that PKG_CONFIG_PATH
# and CMAKE_PREFIX_PATH are set properly.

# symbol exists in win32, but function does not.
if(WIN32)
	if(ENABLE_INET_PTON)
		set(CMAKE_REQUIRED_LIBRARIES ws2_32)
		check_function_exists(inet_pton HAVE_INET_PTON)
		add_definitions(-D_WIN32_WINNT=0x0600)
	else()
		add_definitions(-D_WIN32_WINNT=0x0501)
	endif()
else()
	check_function_exists(inet_pton HAVE_INET_PTON)
endif()
if (DEFINED HAVE_INET_PTON)
	add_definitions(-DHAVE_INET_PTON=1)
endif()

if (ENABLE_MONOTONIC_CLOCK)
	add_definitions(-DENABLE_MONOTONIC_CLOCK=1)
endif()

if (ENABLE_ENCRYPTION)
	if ("${USE_ENCLIB}" STREQUAL "gnutls")
		set (SSL_REQUIRED_MODULES "gnutls nettle")
		if (WIN32)
			if (MINGW)
				set (SSL_REQUIRED_MODULES "${SSL_REQUIRED_MODULES} zlib")
			endif()
		endif()

		pkg_check_modules (SSL REQUIRED ${SSL_REQUIRED_MODULES})

		add_definitions(
			-DUSE_GNUTLS=1
		)

		link_directories(
			${SSL_LIBRARY_DIRS}
		)
	else() # Common for mbedtls and openssl
		if ("${USE_ENCLIB}" STREQUAL "mbedtls")
			add_definitions(-DUSE_MBEDTLS=1)
			set (SSL_REQUIRED_MODULES "mbedtls mbedcrypto")
		else()
			add_definitions(-DUSE_OPENSSL=1)
			set (SSL_REQUIRED_MODULES "openssl libcrypto")
		endif()
		# Try using pkg-config method first if enabled,
		# fall back to find_package method otherwise
		if (USE_OPENSSL_PC)
			pkg_check_modules(SSL ${SSL_REQUIRED_MODULES})
		endif()
		if (SSL_FOUND)
			# We have some cases when pkg-config is improperly configured
			# When it doesn't ship the -L and -I options, and the CMAKE_PREFIX_PATH
			# is set (also through `configure`), then we have this problem. If so,
			# set forcefully the -I and -L contents to prefix/include and
			# prefix/lib.
			if ("${SSL_LIBRARY_DIRS}" STREQUAL "")
			if (NOT "${CMAKE_PREFIX_PATH}" STREQUAL "")
				message(STATUS "WARNING: pkg-config has incorrect prefix - enforcing target path prefix: ${CMAKE_PREFIX_PATH}")
				set (SSL_LIBRARY_DIRS ${CMAKE_PREFIX_PATH}/${CMAKE_INSTALL_LIBDIR})
				set (SSL_INCLUDE_DIRS ${CMAKE_PREFIX_PATH}/include)
			endif()
			endif()

			link_directories(
				${SSL_LIBRARY_DIRS}
			)
			message(STATUS "SSL via pkg-config: -L ${SSL_LIBRARY_DIRS} -I ${SSL_INCLUDE_DIRS} -l;${SSL_LIBRARIES}")
		else()
			if ("${USE_ENCLIB}" STREQUAL "mbedtls")
				if ("${SSL_LIBRARY_DIRS}" STREQUAL "")
					set(MBEDTLS_PREFIX "${CMAKE_PREFIX_PATH}" CACHE PATH "The path of mbedtls")
					find_package(MbedTLS REQUIRED)
					set (SSL_INCLUDE_DIRS ${MBEDTLS_INCLUDE_DIR})
					set (SSL_LIBRARIES  ${MBEDTLS_LIBRARIES})
				endif()
				if ("${SSL_LIBRARIES}" STREQUAL "")
					set (SSL_LIBRARIES  mbedtls mbedcrypto)
				endif()
				message(STATUS "SSL enforced mbedtls: -I ${SSL_INCLUDE_DIRS} -l;${SSL_LIBRARIES}")
			else()
				find_package(OpenSSL REQUIRED)
				set (SSL_INCLUDE_DIRS ${OPENSSL_INCLUDE_DIR})
				set (SSL_LIBRARIES ${OPENSSL_LIBRARIES})
				message(STATUS "SSL via find_package(OpenSSL): -I ${SSL_INCLUDE_DIRS} -l;${SSL_LIBRARIES}")
			endif()
		endif()
	endif()

	add_definitions(-DSRT_ENABLE_ENCRYPTION)
	message(STATUS "ENCRYPTION: ENABLED, using: ${SSL_REQUIRED_MODULES}")
	message (STATUS "SSL libraries: ${SSL_LIBRARIES}")
else()
	message(STATUS "ENCRYPTION: DISABLED")
endif()

if ( USE_GNUSTL )
	pkg_check_modules (GNUSTL REQUIRED gnustl)
	link_directories(${GNUSTL_LIBRARY_DIRS})
	include_directories(${GNUSTL_INCLUDE_DIRS})
	set (SRT_LIBS_PRIVATE ${SRT_LIBS_PRIVATE} ${GNUSTL_LIBRARIES} ${GNUSTL_LDFLAGS})
endif()

# Detect if the compiler is GNU compatable for flags
if(CMAKE_CXX_COMPILER_ID MATCHES "GNU|Intel|Clang|AppleClang")
	message(STATUS "COMPILER: ${CMAKE_CXX_COMPILER_ID} (${CMAKE_CXX_COMPILER}) - GNU compat")
	set(HAVE_COMPILER_GNU_COMPAT 1)
else()
	message(STATUS "COMPILER: ${CMAKE_CXX_COMPILER_ID} (${CMAKE_CXX_COMPILER}) - NOT GNU compat")
	set(HAVE_COMPILER_GNU_COMPAT 0)
endif()

if (DISABLE_CXX11)
	set (ENABLE_CXX11 0)
elseif( DEFINED ENABLE_CXX11 )
else()
	set (ENABLE_CXX11 1)
endif()

if (NOT ENABLE_CXX11)
	message(WARNING "Parts that require C++11 support will be disabled (srt-live-transmit)")
endif()

# add extra warning flags for gccish compilers
if (HAVE_COMPILER_GNU_COMPAT)
	set (SRT_GCC_WARN "-Wall -Wextra")
else()
	# cpp debugging on Windows :D
	#set (SRT_GCC_WARN "/showIncludes")
endif()

if (USE_STATIC_LIBSTDCXX)
	if (HAVE_COMPILER_GNU_COMPAT)
		set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -static-libstdc++")
	else()
		message(FATAL_ERROR "On non-GNU-compat compiler it's not known how to use static C++ standard library.")
	endif()
endif()

# We need clock_gettime, but on some systems this is only provided
# by librt. Check if librt is required.
if (ENABLE_MONOTONIC_CLOCK AND LINUX)

=== debian/changelog ===
srt (1.4.1-5~mx17+1) mx; urgency=medium

  * Rebuild for MX Linux.
  * Revert to debhelper-compat=12.

 -- Steven Pusser <stevep@mxlinux.org>  Mon, 22 Jun 2020 08:19:59 -0700

srt (1.4.1-5) unstable; urgency=medium

  * Update Conflicts / Provides

 -- Federico Ceratto <federico@debian.org>  Sun, 14 Jun 2020 10:47:47 +0100

srt (1.4.1-4) unstable; urgency=medium

  * Add Break + Replaces (Closes: #962624)
    Thanks to Gianfranco Costamagna <locutusofborg@debian.org>

 -- Federico Ceratto <federico@debian.org>  Sat, 13 Jun 2020 00:17:35 +0100

srt (1.4.1-3) unstable; urgency=medium

  [ Jonas Smedegaard ]
  * fix multiarch paths (Closes: #962619)

 -- Federico Ceratto <federico@debian.org>  Wed, 10 Jun 2020 20:33:17 +0100

srt (1.4.1-2) unstable; urgency=medium

  * Split build against OpenSSL and GnuTLS (Closes: #933180)

 -- Federico Ceratto <federico@debian.org>  Tue, 19 May 2020 23:54:34 +0100

srt (1.4.1-1) unstable; urgency=medium

  * New upstream release
  * Add libssl-dev dep (Closes: #933178)

 -- Federico Ceratto <federico@debian.org>  Sat, 09 May 2020 23:39:04 +0100

=== debian/control ===
Source: srt
Priority: optional
Maintainer: Steven Pusser <stevep@mxlinux.org>
XSBC-Original-Maintainer: Federico Ceratto <federico@debian.org>
Build-Depends: debhelper-compat (= 12),
 cmake,
 chrpath,
 help2man,
 libgnutls28-dev,
 libssl-dev,
 pkg-config,
 python3-sphinx,
 tclsh
Standards-Version: 4.5.0
Section: libs
Homepage: https://github.com/Haivision/srt
Vcs-Browser: https://salsa.debian.org/debian/libsrt
Vcs-Git: https://salsa.debian.org/debian/libsrt.git

Package: libsrt1-openssl
Architecture: any
Breaks: libsrt1 (<< 1.4.1-3)
Replaces: libsrt1 (<< 1.4.1-3)
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Conflicts: libsrt1
Provides: libsrt1  (= ${binary:Version})
Description: Secure Reliable Transport UDP streaming library (OpenSSL flavour)
 SRT is a latency-aware UDP transport mechanism optimized for video streams.
 It detects and compensates for jitter and bandwidth fluctuations due to
 network congestion. It mitigates packet loss and supports AES encryption.
 .
 SSL support is provided by OpenSSL.

Package: libsrt1-gnutls
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Secure Reliable Transport UDP streaming library (GnuTLS flavour)
 SRT is a latency-aware UDP transport mechanism optimized for video streams.
 It detects and compensates for jitter and bandwidth fluctuations due to
 network congestion. It mitigates packet loss and supports AES encryption.
 .
 SSL support is provided by GnuTLS.

Package: libsrt-openssl-dev
Section: libdevel
Breaks: libsrt-dev (<< 1.4.1-2)
Replaces: libsrt-dev (<< 1.4.1-2)
Architecture: any
Multi-Arch: same
Conflicts: libsrt-gnutls-dev, libsrt-dev
Depends: libsrt1-openssl (= ${binary:Version}), ${misc:Depends}
Suggests: libsrt-doc (= ${binary:Version}), libssl-dev (>= 1.1)
Description: Secure Reliable Transport UDP streaming library
 SRT is a latency-aware UDP transport mechanism optimized for video streams.
 It detects and compensates for jitter and bandwidth fluctuations due to
 network congestion. It mitigates packet loss and supports AES encryption.
 .
 This package contains development files for libsrt1
 SSL support is provided by OpenSSL.

Package: libsrt-gnutls-dev
Section: libdevel
Breaks: libsrt-dev (<< 1.4.1-2)
Replaces: libsrt-dev (<< 1.4.1-2)
Architecture: any
Multi-Arch: same
Conflicts: libsrt-openssl-dev, libsrt-dev
Depends: libsrt1-gnutls (= ${binary:Version}), ${misc:Depends}
Suggests: libsrt-doc (= ${binary:Version}), libgnutls28-dev
Description: Secure Reliable Transport UDP streaming library
 SRT is a latency-aware UDP transport mechanism optimized for video streams.
 It detects and compensates for jitter and bandwidth fluctuations due to
 network congestion. It mitigates packet loss and supports AES encryption.
 .
 This package contains development files for libsrt1-gnutls
 SSL support is provided by GnuTLS.

Package: libsrt-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}, ${sphinxdoc:Depends}
Description: Secure Reliable Transport UDP streaming library
 SRT is a latency-aware UDP transport mechanism optimized for video streams.
 It detects and compensates for jitter and bandwidth fluctuations due to
 network congestion. It mitigates packet loss and supports AES encryption.
 .
 This package contains documentation files for libsrt1

Package: srt-tools
Architecture: any
Section: utils
Multi-Arch: foreign
Depends: libsrt1-gnutls (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Description: Secure Reliable Transport UDP streaming library
 SRT is a latency-aware UDP transport mechanism optimized for video streams.
 It detects and compensates for jitter and bandwidth fluctuations due to
 network congestion. It mitigates packet loss and supports AES encryption.
 .
 This package contains CLI tool.

=== debian/rules ===
#!/usr/bin/make -f
export DH_VERBOSE = 1
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

# Standardized flags from /usr/share/perl5/Debian/Debhelper/Buildsystem/cmake.pm.
CMAKE_OPTS := -DCMAKE_INSTALL_PREFIX=/usr -DCMAKE_BUILD_TYPE=None -DCMAKE_INSTALL_SYSCONFDIR=/etc -DCMAKE_INSTALL_LOCALSTATEDIR=/var -DCMAKE_EXPORT_NO_PACKAGE_REGISTRY=ON -DCMAKE_FIND_PACKAGE_NO_PACKAGE_REGISTRY=ON

ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
  NUMJOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
  MAKEFLAGS += -j$(NUMJOBS)
endif

include /usr/share/dpkg/default.mk  # provides DEB_VERSION

#export USE_ENCLIB=openssl|gnutls
export USE_ENCLIB=gnutls

%:
	dh $@ --with sphinxdoc

override_dh_auto_clean:
	dh_clean
	rm -rf CMakeFiles/ debian/html build-openssl build-gnutls

override_dh_auto_configure:
	#dh_auto_configure --builddirectory=debian/build/openssl \
	#	-- --use-enclib=openssl
	#dh_auto_configure --builddirectory=debian/build/gnutls \
	#	-- --use-enclib=gnutls
	mkdir -p build-openssl build-gnutls
	cd build-openssl && cmake .. $(CMAKE_OPTS) -DUSE_ENCLIB=openssl
	cd build-gnutls && cmake .. $(CMAKE_OPTS) -DUSE_ENCLIB=gnutls -DTARGET_srt=srt-gnutls

override_dh_auto_build:
	#dh_auto_build --builddirectory=debian/build/openssl
	#dh_auto_build --builddirectory=debian/build/gnutls
	mkdir -p build-openssl build-gnutls
	cd build-openssl && $(MAKE)
	cd build-gnutls && $(MAKE)
	http_proxy='http://127.0.0.1:9/' python3 -m sphinx -N -c debian -bhtml docs debian/html

override_dh_auto_install:
	#dh_auto_install
	#mkdir -p debian/libsrt1-openssl/usr/lib/$(DEB_HOST_MULTIARCH)
	#cp debian/build/openssl/libsrt*so* debian/libsrt1-openssl/usr/lib/$(DEB_HOST_MULTIARCH)/
	#mkdir -p debian/libsrt1-gnutls/usr/lib/$(DEB_HOST_MULTIARCH)
	#cp debian/build/gnutls/libsrt*so* debian/libsrt1-gnutls/usr/lib/$(DEB_HOST_MULTIARCH)/
	#mkdir -p ./debian/srt-tools/usr/bin
	#for n in srt-file-transmit srt-live-transmit srt-tunnel; do \
	#	cp debian/build/gnutls/srt-live-transmit ./debian/srt-tools/usr/bin/; \
	#done
	#test -f ./debian/srt-tools/usr/bin/srt-file-transmit
	install -d debian/tmp
	cd build-openssl && $(MAKE) install DESTDIR=../debian/tmp
	cd build-gnutls && $(MAKE) install DESTDIR=../debian/tmp   # Does not overwrite anything.
	test -f debian/tmp/usr/bin/stransmit || cp debian/tmp/usr/bin/srt-live-transmit debian/tmp/usr/bin/stransmit

override_dh_install:
	dh_install
	install -d debian/libsrt-dev/usr/lib/$(DEB_HOST_MULTIARCH)/pkgconfig/
	install -m 0644 build-openssl/*.pc debian/libsrt-dev/usr/lib/$(DEB_HOST_MULTIARCH)/pkgconfig/
	install -d debian/libsrt-gnutls-dev/usr/lib/$(DEB_HOST_MULTIARCH)/pkgconfig/
	install -m 0644 build-gnutls/*.pc debian/libsrt-gnutls-dev/usr/lib/$(DEB_HOST_MULTIARCH)/pkgconfig/

override_dh_installman-indep:

override_dh_installman-arch:
	help2man --no-discard-stderr --no-info --version-string="$(DEB_VERSION)" \
	--name "" \
	-o ./debian/srt-file-transmit.1 ./build-gnutls/srt-file-transmit
	help2man --no-discard-stderr --no-info --version-string="$(DEB_VERSION)" \
	--name "" \
	-o ./debian/srt-live-transmit.1 ./build-gnutls/srt-live-transmit
	dh_installman

override_dh_strip:
	dh_strip --no-automatic-dbgsym

## srt 1.4.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -11,7 +11,7 @@
 # XXX This can be potentially done in future, but there still exist
 # some dependent project using cmake 2.8 - this can't be done this way.
 #cmake_minimum_required (VERSION 3.0.2 FATAL_ERROR)
-#project(SRT VERSION "1.4.1")
+#project(SRT VERSION "1.4.2")
 project(SRT C CXX)
 
 set (CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/scripts")
@@ -23,11 +23,15 @@
 
 # Platform shortcuts
 string(TOLOWER ${CMAKE_SYSTEM_NAME} SYSNAME_LC)
-set_if(DARWIN      ${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
+set_if(DARWIN	   (${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
+					OR (${CMAKE_SYSTEM_NAME} MATCHES "iOS")
+					OR (${CMAKE_SYSTEM_NAME} MATCHES "tvOS")
+					OR (${CMAKE_SYSTEM_NAME} MATCHES "watchOS"))
 set_if(LINUX       ${CMAKE_SYSTEM_NAME} MATCHES "Linux")
 set_if(BSD         ${SYSNAME_LC} MATCHES "bsd$")
 set_if(MICROSOFT   WIN32 AND (NOT MINGW AND NOT CYGWIN))
 set_if(GNU         ${CMAKE_SYSTEM_NAME} MATCHES "GNU")
+set_if(POSIX       LINUX OR DARWIN OR BSD OR (CYGWIN AND CYGWIN_USE_POSIX))
 set_if(SYMLINKABLE LINUX OR DARWIN OR BSD OR CYGWIN OR GNU)
 
 # Not sure what to do in case of compiling by MSVC.
@@ -39,7 +43,7 @@
 	include(GNUInstallDirs)
 endif()
 
-set (SRT_VERSION 1.4.1)
+set (SRT_VERSION 1.4.2)
 set_version_variables(SRT_VERSION ${SRT_VERSION})
 
 # The CMAKE_BUILD_TYPE seems not to be always set, weird.
@@ -79,10 +83,17 @@
 	add_definitions(-D${ef}${val})
 endforeach()
 
+# NOTE: Known options you can change using ENFORCE_ variables:
+
+# SRT_ENABLE_ECN 1                /* Early Congestion Notification (for source bitrate control) */
+# SRT_DEBUG_TSBPD_OUTJITTER 1     /* Packet Delivery histogram */
+# SRT_DEBUG_TSBPD_DRIFT 1         /* Debug Encoder-Decoder Drift) */
+# SRT_DEBUG_TSBPD_WRAP 1          /* Debug packet timestamp wraparound */
+# SRT_DEBUG_TLPKTDROP_DROPSEQ 1
+# SRT_DEBUG_SNDQ_HIGHRATE 1
+# SRT_MAVG_SAMPLING_RATE 40       /* Max sampling rate */
+
 # option defaults
-# XXX CHANGE: Logging is enabled now by default,
-# use ENABLE_LOGGING=NO in cmake or
-# --disable-logging in configure.
 set(ENABLE_HEAVY_LOGGING_DEFAULT OFF)
 
 # Always turn logging on if the build type is debug
@@ -95,6 +106,8 @@
 option(CYGWIN_USE_POSIX "Should the POSIX API be used for cygwin. Ignored if the system isn't cygwin." OFF)
 option(ENABLE_CXX11 "Should the c++11 parts (srt-live-transmit) be enabled" ON)
 option(ENABLE_APPS "Should the Support Applications be Built?" ON)
+option(ENABLE_EXPERIMENTAL_BONDING "Should the EXPERIMENTAL bonding functionality be enabled?" OFF)
+option(ENABLE_TESTING "Should the Developer Test Applications be Built?" OFF)
 option(ENABLE_PROFILE "Should instrument the code for profiling. Ignored for non-GNU compiler." $ENV{HAI_BUILD_PROFILE})
 option(ENABLE_LOGGING "Should logging be enabled" ON)
 option(ENABLE_HEAVY_LOGGING "Should heavy debug logging be enabled" ${ENABLE_HEAVY_LOGGING_DEFAULT})
@@ -102,7 +115,6 @@
 option(ENABLE_SHARED "Should libsrt be built as a shared library" ON)
 option(ENABLE_STATIC "Should libsrt be built as a static library" ON)
 option(ENABLE_RELATIVE_LIBPATH "Should application contain relative library paths, like ../lib" OFF)
-option(ENABLE_SUFLIP "Should suflip tool be built" OFF)
 option(ENABLE_GETNAMEINFO "In-logs sockaddr-to-string should do rev-dns" OFF)
 option(ENABLE_UNITTESTS "Enable unit tests" OFF)
 option(ENABLE_ENCRYPTION "Enable encryption in SRT" ON)
@@ -111,11 +123,22 @@
 option(ENABLE_INET_PTON "Set to OFF to prevent usage of inet_pton when building against modern SDKs while still requiring compatibility with older Windows versions, such as Windows XP, Windows Server 2003 etc." ON)
 option(ENABLE_CODE_COVERAGE "Enable code coverage reporting" OFF)
 option(ENABLE_MONOTONIC_CLOCK "Enforced clock_gettime with monotonic clock on GC CV /temporary fix for #729/" OFF)
+option(ENABLE_STDCXX_SYNC "Use C++11 chrono and threads for timing instead of pthreads" OFF)
 option(USE_OPENSSL_PC "Use pkg-config to find OpenSSL libraries" ON)
 option(USE_BUSY_WAITING "Enable more accurate sending times at a cost of potentially higher CPU load" OFF)
 option(USE_GNUSTL "Get c++ library/headers from the gnustl.pc" OFF)
+option(ENABLE_SOCK_CLOEXEC "Enable setting SOCK_CLOEXEC on a socket" ON)
 
 set(TARGET_srt "srt" CACHE STRING "The name for the SRT library")
+
+# Use application-defined group reader
+# (currently the only one implemented)
+add_definitions(-DSRT_ENABLE_APP_READER)
+
+# XXX This was added once as experimental, it is now in force for
+# write-blocking-mode sockets. Still unclear if all issues around
+# closing while data still not written are eliminated.
+add_definitions(-DSRT_ENABLE_CLOSE_SYNCH)
 
 if (NOT ENABLE_LOGGING)
 	set (ENABLE_HEAVY_LOGGING OFF)
@@ -160,28 +183,50 @@
 set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR})
 set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR})
 
-# Handle WITH_COMPILER_PREFIX and WITH_COMPILER_TYPE options
-if (DEFINED WITH_COMPILER_PREFIX)
-	message(STATUS "Handling compiler with WITH_COMPILER_PREFIX=${WITH_COMPILER_PREFIX}")
-	# Check also type. Default is gcc.
-	if (NOT DEFINED WITH_COMPILER_TYPE)
-		set (WITH_COMPILER_TYPE gcc)
-	endif()
-
-	if (${WITH_COMPILER_TYPE} STREQUAL gcc)
-		set (CMAKE_C_COMPILER ${WITH_COMPILER_PREFIX}gcc)
-		set (CMAKE_CXX_COMPILER ${WITH_COMPILER_PREFIX}g++)
-	elseif (${WITH_COMPILER_TYPE} STREQUAL cc)
-		set (CMAKE_C_COMPILER ${WITH_COMPILER_PREFIX}cc)
-		set (CMAKE_CXX_COMPILER ${WITH_COMPILER_PREFIX}c++)
+if (NOT DEFINED WITH_COMPILER_TYPE)
+
+	# This is for a case when you provided the prefix, but you didn't
+	# provide compiler type. This option is in this form predicted to work
+	# only on POSIX systems. Just typical compilers for Linux and Mac are
+	# included. 
+	if (DARWIN)
+		set (WITH_COMPILER_TYPE clang)
+	elseif (POSIX) # Posix, but not DARWIN
+		set(WITH_COMPILER_TYPE gcc)
+	else()
+		get_filename_component(WITH_COMPILER_TYPE ${CMAKE_C_COMPILER} NAME)
+	endif()
+	set (USING_DEFAULT_COMPILER_PREFIX 1)
+endif()
+
+if (NOT USING_DEFAULT_COMPILER_PREFIX OR DEFINED WITH_COMPILER_PREFIX)
+	message(STATUS "Handling compiler with PREFIX=${WITH_COMPILER_PREFIX} TYPE=${WITH_COMPILER_TYPE}")
+
+	parse_compiler_type(${WITH_COMPILER_TYPE} COMPILER_TYPE COMPILER_SUFFIX)
+
+	if (${COMPILER_TYPE} STREQUAL gcc)
+		set (CMAKE_C_COMPILER ${WITH_COMPILER_PREFIX}gcc${COMPILER_SUFFIX})
+		set (CMAKE_CXX_COMPILER ${WITH_COMPILER_PREFIX}g++${COMPILER_SUFFIX})
+		set (HAVE_COMPILER_GNU_COMPAT 1)
+	elseif (${COMPILER_TYPE} STREQUAL cc)
+		set (CMAKE_C_COMPILER ${WITH_COMPILER_PREFIX}cc${COMPILER_SUFFIX})
+		set (CMAKE_CXX_COMPILER ${WITH_COMPILER_PREFIX}c++${COMPILER_SUFFIX})
+		set (HAVE_COMPILER_GNU_COMPAT 1)
+	elseif (${COMPILER_TYPE} STREQUAL icc)
+		set (CMAKE_C_COMPILER ${WITH_COMPILER_PREFIX}icc${COMPILER_SUFFIX})
+		set (CMAKE_CXX_COMPILER ${WITH_COMPILER_PREFIX}icpc${COMPILER_SUFFIX})
+		set (HAVE_COMPILER_GNU_COMPAT 1)
 	else()
 		# Use blindly <command> for C compiler and <command>++ for C++.
 		# At least this matches clang.
 		set (CMAKE_C_COMPILER ${WITH_COMPILER_PREFIX}${WITH_COMPILER_TYPE})
-		set (CMAKE_CXX_COMPILER ${WITH_COMPILER_PREFIX}${WITH_COMPILER_TYPE}++)
-	endif()
-
+		set (CMAKE_CXX_COMPILER ${WITH_COMPILER_PREFIX}${COMPILER_TYPE}++${COMPILER_SUFFIX})
+		if (${COMPILER_TYPE} STREQUAL clang)
+			set (HAVE_COMPILER_GNU_COMPAT 1)
+		endif()
+	endif()
 	message(STATUS "Compiler type: ${WITH_COMPILER_TYPE}. C: ${CMAKE_C_COMPILER}; C++: ${CMAKE_CXX_COMPILER}")
+	unset(USING_DEFAULT_COMPILER_PREFIX)
 else()
 	message(STATUS "No WITH_COMPILER_PREFIX - using C++ compiler ${CMAKE_CXX_COMPILER}")
 endif()
@@ -269,71 +314,3 @@
 					set(MBEDTLS_PREFIX "${CMAKE_PREFIX_PATH}" CACHE PATH "The path of mbedtls")
 					find_package(MbedTLS REQUIRED)
 					set (SSL_INCLUDE_DIRS ${MBEDTLS_INCLUDE_DIR})
-					set (SSL_LIBRARIES  ${MBEDTLS_LIBRARIES})
-				endif()
-				if ("${SSL_LIBRARIES}" STREQUAL "")
-					set (SSL_LIBRARIES  mbedtls mbedcrypto)
-				endif()
-				message(STATUS "SSL enforced mbedtls: -I ${SSL_INCLUDE_DIRS} -l;${SSL_LIBRARIES}")
-			else()
-				find_package(OpenSSL REQUIRED)
-				set (SSL_INCLUDE_DIRS ${OPENSSL_INCLUDE_DIR})
-				set (SSL_LIBRARIES ${OPENSSL_LIBRARIES})
-				message(STATUS "SSL via find_package(OpenSSL): -I ${SSL_INCLUDE_DIRS} -l;${SSL_LIBRARIES}")
-			endif()
-		endif()
-	endif()
-
-	add_definitions(-DSRT_ENABLE_ENCRYPTION)
-	message(STATUS "ENCRYPTION: ENABLED, using: ${SSL_REQUIRED_MODULES}")
-	message (STATUS "SSL libraries: ${SSL_LIBRARIES}")
-else()
-	message(STATUS "ENCRYPTION: DISABLED")
-endif()
-
-if ( USE_GNUSTL )
-	pkg_check_modules (GNUSTL REQUIRED gnustl)
-	link_directories(${GNUSTL_LIBRARY_DIRS})
-	include_directories(${GNUSTL_INCLUDE_DIRS})
-	set (SRT_LIBS_PRIVATE ${SRT_LIBS_PRIVATE} ${GNUSTL_LIBRARIES} ${GNUSTL_LDFLAGS})
-endif()
-
-# Detect if the compiler is GNU compatable for flags
-if(CMAKE_CXX_COMPILER_ID MATCHES "GNU|Intel|Clang|AppleClang")
-	message(STATUS "COMPILER: ${CMAKE_CXX_COMPILER_ID} (${CMAKE_CXX_COMPILER}) - GNU compat")
-	set(HAVE_COMPILER_GNU_COMPAT 1)
-else()
-	message(STATUS "COMPILER: ${CMAKE_CXX_COMPILER_ID} (${CMAKE_CXX_COMPILER}) - NOT GNU compat")
-	set(HAVE_COMPILER_GNU_COMPAT 0)
-endif()
-
-if (DISABLE_CXX11)
-	set (ENABLE_CXX11 0)
-elseif( DEFINED ENABLE_CXX11 )
-else()
-	set (ENABLE_CXX11 1)
-endif()
-
-if (NOT ENABLE_CXX11)
-	message(WARNING "Parts that require C++11 support will be disabled (srt-live-transmit)")
-endif()
-
-# add extra warning flags for gccish compilers
-if (HAVE_COMPILER_GNU_COMPAT)
-	set (SRT_GCC_WARN "-Wall -Wextra")
-else()
-	# cpp debugging on Windows :D
-	#set (SRT_GCC_WARN "/showIncludes")
-endif()
-
-if (USE_STATIC_LIBSTDCXX)
-	if (HAVE_COMPILER_GNU_COMPAT)
-		set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -static-libstdc++")
-	else()
-		message(FATAL_ERROR "On non-GNU-compat compiler it's not known how to use static C++ standard library.")
-	endif()
-endif()
-
-# We need clock_gettime, but on some systems this is only provided
-# by librt. Check if librt is required.
-if (ENABLE_MONOTONIC_CLOCK AND LINUX)

=== scripts/changelog/requirements.txt ===
click>=7.1.2
numpy>=1.19.1
pandas>=0.25.3

=== debian/changelog ===
srt (1.4.2-2) unstable; urgency=medium

  * A bugfixes-first-more-invasive-changes-later release

  [ Federico Ceratto ]
  * [a7c6458] Remove myself as maintainer

  [ Florian Ernst ]
  * [47532c2] fix FTFBS with GCC-11 by adding '#include <limits>' to
    srtcore/sync.h.  Thanks to Steve Langasek (Closes: #984352)
  * [a62d7c3] libsrt-openssl-dev: install correct pkg-config file
    (Closes: #1001529)
  * [bf212f4] debian/control: new maintainer (Closes: #964904)

 -- Florian Ernst <florian@debian.org>  Fri, 25 Feb 2022 18:01:07 +0100

srt (1.4.2-1.4) unstable; urgency=medium

  * Non-maintainer upload.
  * Fix FTBFS on kfreebsd

 -- Laurent Bigonville <bigon@debian.org>  Tue, 27 Jul 2021 12:29:44 +0200

srt (1.4.2-1.3) unstable; urgency=medium

  * Fix arch-indep-only builds by not trying to install the libraries that
    were not built.

 -- Sebastian Dröge <slomo@debian.org>  Tue, 19 Jan 2021 16:15:04 +0200

srt (1.4.2-1.2) unstable; urgency=medium

  * Source-only upload without changes.

 -- Sebastian Dröge <slomo@debian.org>  Tue, 19 Jan 2021 14:27:41 +0200

srt (1.4.2-1.1) unstable; urgency=medium

  [ Federico Ceratto ]
  * Pass flags to cmake (Closes: #971811)
    Thanks to Helmut Grohne <helmut@subdivi.de>

  [ Sebastian Dröge ]
  * Include upstream patch to make the major.minor version the soname. Between
    minor releases there won't be any further ABI changes. (Closes: #971754)

    As a result of this also rename the binary packages accordingly.

    Patch taken from https://github.com/Haivision/srt/pull/1741

 -- Sebastian Dröge <slomo@debian.org>  Sat, 16 Jan 2021 10:30:39 +0200

srt (1.4.2-1) unstable; urgency=medium

  * New upstream release (Closes: #963798)
    Thanks to Vasyl Gello <vasek.gello@gmail.com>

 -- Federico Ceratto <federico@debian.org>  Sat, 03 Oct 2020 11:40:07 +0100

=== debian/control ===
Source: srt
Priority: optional
Maintainer: Florian Ernst <florian@debian.org>
Build-Depends:  debhelper (>=12) ,
 cmake,
 chrpath,
 help2man,
 libgnutls28-dev,
 libssl-dev,
 pkg-config,
 tclsh
Build-Depends-Indep: python3-sphinx
Standards-Version: 4.5.0
Section: libs
Homepage: https://github.com/Haivision/srt
Vcs-Browser: https://salsa.debian.org/debian/libsrt
Vcs-Git: https://salsa.debian.org/debian/libsrt.git
Rules-Requires-Root: no

Package: libsrt1.4-openssl
Architecture: any
Breaks: libsrt1 (<< 1.4.1-3), libsrt1-openssl
Replaces: libsrt1 (<< 1.4.1-3), libsrt1-openssl
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Secure Reliable Transport UDP streaming library (OpenSSL flavour)
 SRT is a latency-aware UDP transport mechanism optimized for video streams.
 It detects and compensates for jitter and bandwidth fluctuations due to
 network congestion. It mitigates packet loss and supports AES encryption.
 .
 SSL support is provided by OpenSSL.

Package: libsrt1.4-gnutls
Architecture: any
Breaks: libsrt1-gnutls
Replaces: libsrt1-gnutls
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Secure Reliable Transport UDP streaming library (GnuTLS flavour)
 SRT is a latency-aware UDP transport mechanism optimized for video streams.
 It detects and compensates for jitter and bandwidth fluctuations due to
 network congestion. It mitigates packet loss and supports AES encryption.
 .
 SSL support is provided by GnuTLS.

Package: libsrt-openssl-dev
Section: libdevel
Breaks: libsrt-dev (<< 1.4.1-2)
Replaces: libsrt-dev (<< 1.4.1-2)
Architecture: any
Multi-Arch: same
Conflicts: libsrt-gnutls-dev, libsrt-dev
Depends: libsrt1.4-openssl (= ${binary:Version}), ${misc:Depends}
Suggests: libsrt-doc (= ${binary:Version}), libssl-dev (>= 1.1)
Description: Secure Reliable Transport UDP streaming library
 SRT is a latency-aware UDP transport mechanism optimized for video streams.
 It detects and compensates for jitter and bandwidth fluctuations due to
 network congestion. It mitigates packet loss and supports AES encryption.
 .
 This package contains development files for libsrt1.4
 SSL support is provided by OpenSSL.

Package: libsrt-gnutls-dev
Section: libdevel
Breaks: libsrt-dev (<< 1.4.1-2)
Replaces: libsrt-dev (<< 1.4.1-2)
Architecture: any
Multi-Arch: same
Conflicts: libsrt-openssl-dev, libsrt-dev
Depends: libsrt1.4-gnutls (= ${binary:Version}), ${misc:Depends}
Suggests: libsrt-doc (= ${binary:Version}), libgnutls28-dev
Description: Secure Reliable Transport UDP streaming library
 SRT is a latency-aware UDP transport mechanism optimized for video streams.
 It detects and compensates for jitter and bandwidth fluctuations due to
 network congestion. It mitigates packet loss and supports AES encryption.
 .
 This package contains development files for libsrt1.4-gnutls
 SSL support is provided by GnuTLS.

Package: libsrt-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}, ${sphinxdoc:Depends}
Description: Secure Reliable Transport UDP streaming library
 SRT is a latency-aware UDP transport mechanism optimized for video streams.
 It detects and compensates for jitter and bandwidth fluctuations due to
 network congestion. It mitigates packet loss and supports AES encryption.
 .
 This package contains documentation files for libsrt1.4

Package: srt-tools
Architecture: any
Section: utils
Multi-Arch: foreign
Depends: libsrt1.4-gnutls (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Description: Secure Reliable Transport UDP streaming library
 SRT is a latency-aware UDP transport mechanism optimized for video streams.
 It detects and compensates for jitter and bandwidth fluctuations due to
 network congestion. It mitigates packet loss and supports AES encryption.
 .
 This package contains CLI tool.

=== debian/rules ===
--- 
+++ 
@@ -18,35 +18,33 @@
 export USE_ENCLIB=gnutls
 
 %:
-	dh $@ --with sphinxdoc
+	dh $@ --buildsystem=cmake+makefile
 
 override_dh_auto_clean:
 	dh_clean
 	rm -rf CMakeFiles/ debian/html build-openssl build-gnutls
+	rm -rf CMakeFiles/ debian/doctrees debian/html build-openssl build-gnutls
 
 override_dh_auto_configure:
-	#dh_auto_configure --builddirectory=debian/build/openssl \
-	#	-- --use-enclib=openssl
-	#dh_auto_configure --builddirectory=debian/build/gnutls \
-	#	-- --use-enclib=gnutls
-	mkdir -p build-openssl build-gnutls
-	cd build-openssl && cmake .. $(CMAKE_OPTS) -DUSE_ENCLIB=openssl
-	cd build-gnutls && cmake .. $(CMAKE_OPTS) -DUSE_ENCLIB=gnutls -DTARGET_srt=srt-gnutls
+	dh_auto_configure --builddirectory=build-openssl -- $(CMAKE_OPTS) -DUSE_ENCLIB=openssl
+	dh_auto_configure --builddirectory=build-gnutls -- $(CMAKE_OPTS) -DUSE_ENCLIB=gnutls -DTARGET_srt=srt-gnutls
 
-override_dh_auto_build:
+override_dh_auto_build-arch:
 	#dh_auto_build --builddirectory=debian/build/openssl
 	#dh_auto_build --builddirectory=debian/build/gnutls
 	mkdir -p build-openssl build-gnutls
 	cd build-openssl && $(MAKE)
 	cd build-gnutls && $(MAKE)
-	http_proxy='http://127.0.0.1:9/' python3 -m sphinx -N -c debian -bhtml docs debian/html
 
-override_dh_auto_install:
+override_dh_auto_build-indep:
+	http_proxy='http://127.0.0.1:9/' python3 -m sphinx -N -c debian -d debian/doctrees -bhtml docs debian/html
+
+override_dh_auto_install-arch:
 	#dh_auto_install
-	#mkdir -p debian/libsrt1-openssl/usr/lib/$(DEB_HOST_MULTIARCH)
-	#cp debian/build/openssl/libsrt*so* debian/libsrt1-openssl/usr/lib/$(DEB_HOST_MULTIARCH)/
-	#mkdir -p debian/libsrt1-gnutls/usr/lib/$(DEB_HOST_MULTIARCH)
-	#cp debian/build/gnutls/libsrt*so* debian/libsrt1-gnutls/usr/lib/$(DEB_HOST_MULTIARCH)/
+	#mkdir -p debian/libsrt1.4-openssl/usr/lib/$(DEB_HOST_MULTIARCH)
+	#cp debian/build/openssl/libsrt*so* debian/libsrt1.4-openssl/usr/lib/$(DEB_HOST_MULTIARCH)/
+	#mkdir -p debian/libsrt1.4-gnutls/usr/lib/$(DEB_HOST_MULTIARCH)
+	#cp debian/build/gnutls/libsrt*so* debian/libsrt1.4-gnutls/usr/lib/$(DEB_HOST_MULTIARCH)/
 	#mkdir -p ./debian/srt-tools/usr/bin
 	#for n in srt-file-transmit srt-live-transmit srt-tunnel; do \
 	#	cp debian/build/gnutls/srt-live-transmit ./debian/srt-tools/usr/bin/; \
@@ -57,10 +55,13 @@
 	cd build-gnutls && $(MAKE) install DESTDIR=../debian/tmp   # Does not overwrite anything.
 	test -f debian/tmp/usr/bin/stransmit || cp debian/tmp/usr/bin/srt-live-transmit debian/tmp/usr/bin/stransmit
 
+override_dh_auto_install-indep:
+
+
 override_dh_install:
 	dh_install
-	install -d debian/libsrt-dev/usr/lib/$(DEB_HOST_MULTIARCH)/pkgconfig/
-	install -m 0644 build-openssl/*.pc debian/libsrt-dev/usr/lib/$(DEB_HOST_MULTIARCH)/pkgconfig/
+	install -d debian/libsrt-openssl-dev/usr/lib/$(DEB_HOST_MULTIARCH)/pkgconfig/
+	install -m 0644 build-openssl/*.pc debian/libsrt-openssl-dev/usr/lib/$(DEB_HOST_MULTIARCH)/pkgconfig/
 	install -d debian/libsrt-gnutls-dev/usr/lib/$(DEB_HOST_MULTIARCH)/pkgconfig/
 	install -m 0644 build-gnutls/*.pc debian/libsrt-gnutls-dev/usr/lib/$(DEB_HOST_MULTIARCH)/pkgconfig/
 
@@ -75,5 +76,5 @@
 	-o ./debian/srt-live-transmit.1 ./build-gnutls/srt-live-transmit
 	dh_installman
 
-override_dh_strip:
-	dh_strip --no-automatic-dbgsym
+override_dh_auto_test:
+	true
